image: docker:stable

# When using dind, it's wise to use the overlayfs driver for
# improved performance.
variables:
  DOCKER_DRIVER: overlay2

services:
- docker:dind

before_script:
- docker info
- docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com

.build:
  stage: build
  except:
    - tags
  script:
    - docker build --build-arg PHP_VERSION=$PHP_VERSION -t registry.gitlab.com/damienduboeuf/docker/php-fpm-symfony:$PHP_VERSION ./

.deploy:
  stage: deploy
  only:
    - tags
  script:
    - docker build --build-arg PHP_VERSION=$PHP_VERSION -t registry.gitlab.com/damienduboeuf/docker/php-fpm-symfony:$PHP_VERSION -t registry.gitlab.com/damienduboeuf/docker/php-fpm-symfony:$PHP_VERSION-$CI_COMMIT_TAG ./
    - docker push registry.gitlab.com/damienduboeuf/docker/php-fpm-symfony:$PHP_VERSION
    - docker push registry.gitlab.com/damienduboeuf/docker/php-fpm-symfony:$PHP_VERSION-$CI_COMMIT_TAG

build70FPM: { extends: .build, variables: { PHP_VERSION: '7.0-fpm' } }
build71FPM: { extends: .build, variables: { PHP_VERSION: '7.1-fpm' } }
build72FPM: { extends: .build, variables: { PHP_VERSION: '7.2-fpm' } }
build73FPM: { extends: .build, variables: { PHP_VERSION: '7.3-fpm' } }
build74FPM: { extends: .build, variables: { PHP_VERSION: '7.4-fpm' } }
build80FPM: { extends: .build, variables: { PHP_VERSION: '8.0-fpm' } }
build81FPM: { extends: .build, variables: { PHP_VERSION: '8.1-fpm' } }
build82FPM: { extends: .build, variables: { PHP_VERSION: '8.2-fpm' } }

deploy70FPM: { extends: .deploy, variables: { PHP_VERSION: '7.0-fpm' } }
deploy71FPM: { extends: .deploy, variables: { PHP_VERSION: '7.1-fpm' } }
deploy72FPM: { extends: .deploy, variables: { PHP_VERSION: '7.2-fpm' } }
deploy73FPM: { extends: .deploy, variables: { PHP_VERSION: '7.3-fpm' } }
deploy74FPM: { extends: .deploy, variables: { PHP_VERSION: '7.4-fpm' } }
deploy80FPM: { extends: .deploy, variables: { PHP_VERSION: '8.0-fpm' } }
deploy81FPM: { extends: .deploy, variables: { PHP_VERSION: '8.1-fpm' } }
deploy82FPM: { extends: .deploy, variables: { PHP_VERSION: '8.2-fpm' } }
